/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkDeclineDog(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postDrunk;
    var subController = ctrl.preDeath;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidDrunkDeclineDad(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var broom = ctrl.drunk.get() === FarmerMaidDrunkChoice.DECLINE;
        var toReturn = ``;

        if (broom) {
            toReturn += `[p]
                            Things rapidly deteriorate from that day onwards.
                            You struggle to cope with the fact that you lost your child,
                            while your bulging belly deflates once more.
                            You can't believe Falco did that.
                            First he knocked you up,
                            and then he gave you an [b]abortion[/b] against your will.
                            You'll never forgive him for that.
                            You refuse to look at him, and he refuses to look at you.
                            Whatever you had going between the two of you is [b]over[/b].
                        [/p]
                        [p]
                            A few weeks later, the bird nags his parents into buying him a new feral dog.
                            A big, burly beast, almost as tall as you are.
                            You think your former lover is doing this just to spite you.
                            But you don't care, as long as it doesn't affect you.
                            If he keeps that mutt away from you, then he can fuck it up the tailhole for all you care.
                        [/p]
                        [p]
                            But being left alone isn't in the hand you were dealt.
                            The canine sleeps in your basket, leaving little room for you.
                            Unable to move it, and kind of [i]scared[/i] of how it constantly [b]growls[/b] at you,
                            you resort to sleeping on the cold, hard floor.
                            And that's only the [b]beginning[/b] of your descent into a new layer of hell.
                        [/p]
                        [p]
                            Falco trains the dog.
                            Teaches it to mount things.
                            Things like [b]you[/b].
                            One day, while you're sweeping the floor as usual,
                            the beast suddenly approaches from behind, rears up and plops its large front paws atop your shoulders,
                            throwing you off balance, [b]forcing[/b] you to the ground.
                            Before you manage to recover, it mounts you, keeping you pinned to the floor through sheer body-weight.
                        [/p]
                        [p]
                            You struggle, but the canine is far too big and heavy for you to shake off.
                            Your heart sinks to your knees as it begins to [b]hump[/b] your rear,
                            painfully prodding its fully erect, tapered member against your plump, scaly behind.
                            From the kitchen, in walks the eagle.
                            You [b]beg[/b] him to get his pet off of you!
                            But instead of helping, he kneels down near your backside, and grabs the feral's shaft.
                            "[color=yellow][b]Bitch[/b].[/color]" is the only word that escapes his beak,
                            as he guides his pet's dick into your still-aching folds, the dog instantly thrusting forwards,
                            ramming itself into your splintery cunt.
                        [/p]
                        [p]
                            You cry out in agony once more,
                            your still fresh internal wounds raked open yet again.
                            The beast doesn't seem to mind the chips of wood embedded into your innards.
                            As its master leaves you to your fate, it wildly begins to [b]hump[/b] away,
                            rapidly pounding your hurting insides with the bestial ferocity that only a feral could muster.
                        [/p]
                        [p]
                            Several minutes of agony later, it stretches your folds to their very limits,
                            as it [b]rams[/b] its thick knot inside of you,
                            hopping off of you and facing away as its hefty balls begin to churn out their contents into your aching hole.
                            Completely [b]broken[/b], you don't even bother to try to pull yourself free from the canine's knot,
                            instead idly bawling your eyes out while waiting for it to deflate.
                        [/p]
                        [p]
                            The dog comes to see you as its [b]property[/b].
                            A toy for it to fuck when it is needy.
                            Be that during the day, while you're trying to clean,
                            at night, while you're trying to sleep,
                            or even in the middle of a conversation with Juliet.
                            After it painfully [b]bites[/b] the back of your neck,
                            you learn not to struggle too much against the feral's actions.
                            It is in control, and not you.
                        [/p]`;
        } else {
            toReturn += `
                        [p]
                            Things rapidly deteriorate from that day onwards.
                            You refuse to look at Falco, and he refuses to look at you.
                            Whatever you had going between the two of you is [b]over[/b].
                            Until he apologizes for his actions, you don't want anything more to do with him.
                        [/p]
                        [p]
                            A few weeks later, the bird nags his parents into buying him a new feral dog.
                            A big, burly beast, almost as tall as you are.
                            You think your former lover is doing this just to spite you.
                            But you don't care, as long as it doesn't affect you.
                            If he keeps that mutt away from you, then he can fuck it up the tailhole for all you care.
                        [/p]
                        [p]
                            But being left alone isn't in the hand you were dealt.
                            The canine sleeps in your basket, leaving little room for you.
                            Unable to move it, and kind of [i]scared[/i] of how it constantly [b]growls[/b] at you,
                            you resort to sleeping on the cold, hard floor.
                            And that's only the [b]beginning[/b] of your descent into a new layer of hell.
                        [/p]
                        [p]
                            Falco trains the dog.
                            Teaches it to mount things.
                            Things like [b]you[/b].
                            One day, while you're sweeping the floor as usual,
                            the beast suddenly approaches from behind, rears up and plops its large front paws atop your shoulders,
                            throwing you off balance, [b]forcing[/b] you to the ground.
                            Before you manage to recover, it mounts you, keeping you pinned to the floor through sheer body-weight.
                        [/p]
                        [p]
                            You struggle, but the canine is far too big and heavy for you to shake off.
                            Your heart sinks to your knees as it begins to [b]hump[/b] your rear,
                            painfully prodding its fully erect, tapered member against your plump, scaly behind.
                            From the kitchen, in walks the eagle.
                            You [b]beg[/b] him to get his pet off of you!
                            But instead of helping, he kneels down near your backside, and grabs the feral's shaft.
                            "[color=yellow][b]Bitch[/b].[/color]" is the only word that escapes his beak,
                            as he guides his pet's dick into your folds, the dog instantly thrusting forwards,
                            ramming itself into your pregnant cunt.
                        [/p]
                        [p]
                            As its master leaves you to your fate, the beast wildly begins to [b]hump[/b] away,
                            rapidly pounding your insides with the bestial ferocity that only a feral could muster.
                            Several minutes of debasing degradation later, it stretches your folds to their very limits,
                            as it [b]rams[/b] its thick knot inside of you,
                            hopping off of you and facing away as its hefty balls begin to churn out their contents into your violated hole.
                            Completely [b]broken[/b], you don't even bother to try to pull yourself free from the canine's knot,
                            instead idly bawling your eyes out while waiting for it to deflate.
                        [/p]
                        [p]
                            The dog comes to see you as its [b]property[/b].
                            A toy for it to fuck when it is needy.
                            Be that during the day, while you're trying to clean,
                            at night, while you're trying to sleep,
                            or even in the middle of a conversation with Juliet.
                            After it painfully [b]bites[/b] the back of your neck,
                            you learn not to struggle too much against the feral's actions.
                            It is in control, and not you.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
