/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriendCapture(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGirlfriendFrameChoice.CAPTURE;
    var reqController = ctrl.frame;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Now is the perfect moment to swoop in, and claim what is yours.
                            You take a seat next to Falco, and comfortingly pat his back.
                            You say that, while you're his slave and all,
                            and your opinion is [i]worthless[/i], you [i]may[/i] have a way of getting back at her.
                            He perks up, and faces you, his interest clearly piqued.
                            The two of you form a devious plan.
                        [/p]
                        [p]
                            Hours later, the bird's [b]ex[/b]-girlfriend comes home.
                            Hiding behind the door, he pops out and [b]snags[/b] the bitch by pulling a small burlap sack over her head.
                            She struggles fiercely, but she's physically [b]no match[/b] for the farmwork-toned eagle.
                            You help to hold her, but not a lot.
                            Once she's calmed down, the two of you escort her to the [i]workshop[/i].
                        [/p]
                        [p]
                            Romeo's friends, the same ones that helped de-fang [b]you[/b],
                            are already waiting for you there.
                            They were more than eager to help, after hearing how the girl had broken their wealthy comrade's son's heart.
                            They keep her in place, her pants tugged down to her knees, her bare rear exposed.
                            You, having come up with this idea, get to do the honors.
                            You retrieve one of the blazing hot irons from the nearby kiln,
                            the same one that was used to mark you.
                            Mercilessly, you press the scorching metal against her smooth-skinned ass, burning the slave-insignia into her flesh.
                        [/p]
                        [p]
                            The lady passes out.
                            When she wakes up, she finds herself in the dog basket that you called your bed for the longest of times.
                            The tables have turned.
                            [i]She[/i] is [b]your[/b] maid now.
                            And if she [b]dares[/b] to leave this house,
                            then the other farmers'll get her,
                            and do [b]horrible[/b] things to her.
                            If Falco doesn't catch her first.
                        [/p]
                        [p]
                            You'd give her your maid outfit, but you don't think it'd fit her, so she'll just have to walk around [b]naked[/b] instead.
                            You've already sold her clothes to buy yourself some extra-nice massage oil, which she can use to rub your feet tomorrow.
                            If she wants to eat, that is.
                            Anyway, Falco already went to bed.
                            It's about time you go join him.
                            After all, you're the kind of girlfriend he [b]deserves[/b].
                            With a cackling laugh, you turn around and walk away,
                            heading up the stairs to spend the first night together with your new [b]lover[/b].
                            Maybe when you're finished fucking, the slave can clean you using her mouth.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Anti-maid end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}
