/**
 * Bite section of the unknown scene.
 * @param {ForestController} controller The forest controller.
 */
function ForestUnknownInitialBiteContinue(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = `initBiteLeftContinueButton`;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var cock = ctrl.unknown.cock();
        var pants = ctrl.unknown.pants();
        var pantsPopup = global.kobold.inventory.createItemWithTooltip(pants);
        var underwear = ctrl.unknown.underwear();
        var underwearPopup = global.kobold.inventory.createItemWithTooltip(underwear);
        var toReturn = `[p]
                            You lay down on the floor for several more minutes, until the sun has disappeared completely,
                            the darkness of night washing over the deepwoods, pseudo-dusk replaced by pitch-blackness.
                            You cry, you sob and you whimper, carefully rubbing your injured wrist.
                            You are shattered, both mentally as well as physically.
                            You feel used, pumped and [b]dumped[/b], taken advantage of by the first creature you encountered in this unhospitable part of the forest.
                        [/p]
                        [p]
                            The ground growing far too cold for comfort, you slowly rise to your shaky feet.
                            The steady stream of sweet-smelling, honey-like nectar flowing from your tailhole has slowed to a trickle, oozing down along your inner thighs.
                        `;

        if (pants) {
            toReturn += `   As you lift yourself off of the ground, the ripped remains of your pant legs slide off of your scaly frame,
                            leaving you naked from the waist-downwards.`;
        } else if (underwear) {
            toReturn += `   As you lift yourself off of the ground, you become aware of the fact that your ${underwearPopup} feels a lot heavier than before.
                            It must have soaked up a lot of the syrup oozing from your butt.`;
        }

        toReturn += `   [/p]
                        [p]
                            Then, you spot something that may offer a bit of consolation, or at the very least a bit of shielding from the steadily dropping temperature.
                            Your ${global.kobold.inventory.createItemWithTooltip(new WoolSweater())}, 
                            which you let go of during the struggle earlier, seems to have survived the fight mostly unscathed.
                            You pick it up off of the ground, and eagerly don it, 
                            focussing your mind on the warmth and comfort it provides to your upper body as opposed to the coldness afflicting your naked rear.
                        [/p]
                        [p]
                            At least you got [i]something[/i] out of this entire ordeal.
                            With your spirit slightly placated although still significantly battered,
                            you begin to ponder your current situation.
                            You doubt you can find your way home in the dark.
                            You are tired, but sleeping in a place this dangerous is [b]not[/b] an option.
                            Your best bet is to keep moving.
                            If you keep going in one direction, you'll reach the edge of this godforsaken forest at one point or another, 
                            and [i]then[/i] you can go home.
                        [/p]
                        [p]
                            Your plan formed, you pick a direction at random, and begin to march forwards,
                            your gait a little distorted by the slight amount of pain radiating from your bottom.
                            Instead of giving up, you double down.
                            You may have suffered a small setback, but you [b]are[/b] going to make it out of here [b]alive[/b],
                            and there's no amount of plants or tentacles, no matter how [b]thick[/b] or [b]slimy[/b],
                            that are you going stop you from doing so.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.unknown.hasContinued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.unknown.continue();
            loadNextPart("RiversideMarsh", "Deepwoods");
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "forestUnknownInitialBiteContinue";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (!ctrl.unknown.pry.initbiterape.continued()) {
            return "";
        }

        global.ui.applyTheme("forest_night");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.unknown.pry.initbiterape.continueChange();
        part += buildChoice();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (!ctrl.unknown.pry.initbiterape.continued()) {
            return;
        }

        if (ctrl.unknown.hasContinued()) {
            return;
        }

        registerContinueListener();
    };
}
