/**
 * Ruby section of Varanar, Afternoon Three.
 * @param {AfternoonThreeRubyController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeRubyPantiesDiscard(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeRubyPantiesChoice.DISCARD;
    var reqController = ctrl.panties;
    var subController = false;
    var changeController = false;

    var autoContinue = true;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.postPanties;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var t1 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt1;
        var t2 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt2;
        var t3 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt3;
        var toReturn = ``;

        if (t1) {
            toReturn += `
                        [p]
                            Hell yeah.
                            You got the bitch to take off her underwear.
                            You don't really want it yourself, though.
                            What would you do with a pair of panties?
                            [i]Wear them[/i]?
                            Yeah right!
                        [/p]
                        [p]
                            To crush the lady's spirit even more,
                            you crudely toss her underwear to the ground, and grind it into the dirt with your foot.
                            "[color=cyan]What are you doing?!
                            Stop that!
                            That's my favorite pair![/color]"
                            [i]Her[/i] favorite pair?
                            No, they're not hers at all.
                            She gave them to you, remember?
                            They're [b]yours[/b].
                            And you get to do with your belongings whatever well you damn please.
                        [/p]
                        [p]
                            To emphasize your statement, you shred the fine silk underneath your foot using your sharp toe-claws.
                            "[color=cyan]You're a [b]monster[/b].[/color]" the dragoness objects.
                            You may be a monster, but she's a [b]bitch[/b].
                        [/p]`;
        } else if (t2) {
            toReturn += `
                        [p]
                            Wow.
                            You got her to take off her underwear.
                            You don't really have any use for it, though.
                            What would you do with a pair of panties?
                            [i]Wear them[/i]?
                            You don't think so.
                            You have to get rid of them somehow, though.
                            Preferably without the dragoness noticing.
                        [/p]
                        [p]
                            With the garment in hand, you [i]pretend[/i] to trip over your own feet,
                            landing on your hands and legs at the edge of the foul mattress.
                            In the blink of an eye, you sleekly hide the panties under the bed,
                            somewhere the dragoness'll [b]never[/b] go looking for them.
                            You rise to your feet once more.
                            The lady doesn't even notice that her undergarment has disappeared from your clutches.
                            She probably thinks you pocketed it somehow.
                        [/p]`;
        } else {
            toReturn += `
                        [p]
                            Wow.
                            She gave you a show and everything.
                            You don't really have any use for these panties, though.
                            What would you do with silk underwear?
                            [i]Wear it[/i]?
                            You don't think so.
                            You have to get rid of it somehow, though.
                            Preferably without upsetting the dragoness.
                        [/p]
                        [p]
                            Acting distraught, you suddenly [b]throw[/b] the garment to the ground, and crudely [b]stomp[/b] on it multiple times.
                            "[color=cyan]What are you doing?!
                            Stop that!
                            That's my favorite pair![/color]"
                            You quickly mention that a [b]venomous spider[/b] had crawled onto the fabric,
                            probably when they were around her ankles.
                            The lady's face goes pale.
                            "[color=cyan]A s-spider?!
                            Thank goodness you got rid of it![/color]"
                            Yeah.
                            You got rid of it alright.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
