/**
 * Bucket section of Varanar, Morning Three.
 * @param {MorningThreeController} controller The Morning Three controller.
 */
function MorningThreeBucketContinue(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preContinue;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var clothed = !ctrl.misc.nude();
        var dick = ctrl.misc.dick();
        var She = dick ? `She` : `He`;
        var he = She.toLowerCase();
        var Her = dick ? `Her` : `His`;
        var his = Her.toLowerCase();
        var Him = dick ? `Her` : `Him`;
        var her = Him.toLowerCase();
        var toReturn = `[p]
                            You ${clothed ? `redress, and` : ``} consider going back to the alley to look for the cyan kobold.
                            After getting so crudely interrupted, you doubt ${he}'d stick around, though.
                            Not to mention the boot ${he} got hit by.
                            You [i]could[/i] go look for ${her} on the other end of the alleyway, but you don't even know where it leads to.
                            ${She}'ll be long gone by the time you get there.
                        [/p]
                        [p]
                            Besides, who knows?
                            Maybe ${he}'s out looking for you [b]right now[/b]!
                            If you went searching for ${her}, you'd just end up missing one another, especially with how crowded the streets seem to be getting.
                            No, the most reasonable thing for you to do, would be to wait here.
                            After all, this is where the two of you met.
                            If there's one place to go that the both of you know, [b]this[/b] would be it.
                            Surely ${he}'ll think to check here, right?
                        [/p]
                        [p]
                            You find a quiet spot near the stage, and sit yourself down on the ground.
                            You wait for seconds, then minutes, which slowly turn into hours.
                            Come high noon, with tears in your eyes, you realize:
                            ${he}'s not coming.
                        [/p]
                        [p]
                            Once again, you are all alone.
                            With a heavy heart, you rise to your feet.
                            The only consolation you can think of, is that one day the two of you may meet again.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.nextSceneName, ctrl.nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.sad.change();
        part += buildChoice();
        if (!ctrl.nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (ctrl.nextSceneReady) {
            registerContinueListener();
        }
    };
}
