/**
 * The kobold's relation with the Dragoness Princess, first encounterable in the
 * forest.
 */
function DragonessPrincess() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.relation = DragonessPrincessEnum.UNMET;
    this.savedBy = DragonessPrincessSavedBy.NOTHING;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};
    
    /**
     * Loads this object from a type-stripped version thereof.
     * @param {DragonessPrincess-stripped} dragonessPrincess A DragonessPrincess object, stripped of private members and all functions.
     */
    this.load = function (dragonessPrincess) {
        if(!dragonessPrincess) {
            that.load(new DragonessPrincess());
            return;
        }
        var defaults = new DragonessPrincess();
        that.relation = dragonessPrincess.relation || defaults.relation;
        that.savedBy = dragonessPrincess.savedBy || defaults.savedBy;
    };
}
