/**
 * The kobold's relation with Seki, first encounterable in the hamlet.
 */
function Seki() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.knowsDying = false;
    this.hamletHadMoney = false;
    this.moneySpent = 0;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};
    
    /**
     * Loads this object from a type-stripped version thereof.
     * @param {DragonessPrincess-stripped} dragonessPrincess A DragonessPrincess object, stripped of private members and all functions.
     */
    this.load = function (seki) {
        if(!seki) {
            that.load(new Seki());
            return;
        }
        that.knowsDying = seki.knowsDying;
        that.hamletHadMoney = seki.hamletHadMoney;
        that.moneySpent = seki.moneySpent;
    };
}
