/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbsent(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preParents;
    var subController = ctrl.parents;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = ctrl.fragments.handjob;
    var secondNext = ctrl.fragments.blowjob;

    var firstChoice = ctrl.parentsChoice.HANDJOB;
    var secondChoice = ctrl.parentsChoice.BLOWJOB;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Near the end of the sixth week, the routine is broken.
                            Falco storms into the dining room, clearly upset about something.
                            Romeo and Juliet are nowhere to be found, as usual.
                            That leaves only [b]you[/b] to vent his frustration on.
                            And he [b]isn't[/b] looking to talk.
                        [/p]
                        [p]
                            The eagle forcibly [b]bends[/b] you over one of the dining table chairs.
                            He lifts your tail, and brings the flat of his palm to bear upon your sensitive butt,
                            harshly [b]spanking[/b] your ass with all of his might.
                            He crudely [b]smacks[/b] your reddening rear again and again and again.
                            You cry out in pain, and [b]beg[/b] for him to stop, every blow stinging more than the last.
                            But he isn't listening.
                            He's intent on discharging every last bit of his hormonal annoyance and anger,
                            even if that means [b]paddling[/b] your behind until you can barely even [b]walk[/b] anymore.
                        [/p]
                        [p]
                            While not as bad as the torture you went through at the start of your enslavement,
                            the following ten minutes still [b]hellish[/b] beyond belief.
                            Your sore hindquarters get struck over and over,
                            your begging pleas and agonized shouts echoing throughout the empty house.
                            The spot around your brandmark hurts the most, your scales still sore from the slave insignia burned into them.
                        [/p]
                        [p]
                            Only after your tears have long run out, does the torment come to an end.
                            But Falco isn't done with you yet.
                            He yanks you off the chair, and onto your knees.
                            Unbuckling and dropping his pants, he presents you his rock-hard member, the tip all but rubbing in your face.
                            "[color=yellow][b]Suck it, slave.[/b][/color]" he states, giving his length a few much-needed strokes.
                            "[color=yellow]Or I'll [b]tear[/b] your outfit and go tell my dad you tried to escape.[/color]"
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>A handjob</button>`;

        var tooltip = global.parser.parse(`You don't have a choice. Use your hands to pleasure the bird. Hope that'll sate him.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>A blowjob</button>`;

        var tooltip = global.parser.parse(`Suck the avian off to please him.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 225px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You give him:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}
